import java.net.*;
import java.io.*;
import java.util.*;

import javax.xml.messaging.*;
import javax.xml.soap.*;

class ExchangeClient {

	public ExchangeClient() {
		sendMessage( "us", "euro" );
	}
	
	protected void sendMessage( String divisaIniziale, String divisaFinale ) {
		try {
			MessageFactory 	mf  = MessageFactory.newInstance();
			SOAPMessage 	msg = mf.createMessage();
			SOAPPart 		sp  = msg.getSOAPPart();
			SOAPEnvelope 	env = sp.getEnvelope();
			SOAPHeader 		hdr = env.getHeader();
			SOAPBody 		bdy = env.getBody();
			
			String xsi = "http://www.w3.org/2001/XMLSchema-instance";
			env.addNamespaceDeclaration("xsi", xsi); 
			env.addNamespaceDeclaration("xsd", "http://www.w3.org/2001/XMLSchema");
			env.setEncodingStyle("http://schemas.xmlsoap.org/soap/encoding/");

			javax.xml.soap.Name xsiTypeString = env.createName("type", "xsi", xsi);
			
			SOAPBodyElement gltp
				= bdy.addBodyElement(env.createName("getRate",
				"ns1",
				"urn:xmethods-CurrencyExchange"));
	
			SOAPElement e1 =
			gltp.addChildElement(env.createName("country1")).addTextNode(divisaIniziale);
			e1.addAttribute( xsiTypeString, "xsd:string" );
			
			SOAPElement e2 =
			gltp.addChildElement(env.createName("country2")).addTextNode(divisaFinale);
			e2.addAttribute( xsiTypeString, "xsd:string" );
								
			FileOutputStream sentFile = new FileOutputStream("sent.xml");
			msg.writeTo(sentFile);
			sentFile.close();
			
			URLEndpoint endpoint = new 
				URLEndpoint(System.getProperty("endpoint"));
			
			SOAPConnectionFactory scf = SOAPConnectionFactory.newInstance();
			SOAPConnection conn = scf.createConnection();
			SOAPMessage response = conn.call( msg, endpoint );
			
			if( response != null ) {
				//L'intestazione XML viene gi messa da sola
				FileOutputStream replyFile = new FileOutputStream("reply.xml");
				response.writeTo(replyFile);
				replyFile.close();
				
				sp = response.getSOAPPart();
				env = sp.getEnvelope();
				bdy = env.getBody();
				Iterator ii = bdy.getChildElements();
				while( ii.hasNext() ) {
					SOAPElement e = (SOAPElement)ii.next();
					printSOAPElement( e );
					
					Iterator kk = e.getChildElements();
					while( kk.hasNext() ) {
						SOAPElement ee = (SOAPElement)kk.next();
						printSOAPElement( ee );
					}
				}
			}
			
		} catch( Exception e ) {
			e.printStackTrace();
		}
	}
	
	protected void printSOAPElement( SOAPElement e ) {
		System.out.print( e.getElementName().getLocalName() );
		System.out.print( " = " );
		System.out.println( e.getValue() );
	}
	
	public static void main( String[] args ) {
		new ExchangeClient();
	}
}