import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

import javax.xml.messaging.*;
import javax.xml.soap.*;

public class ExchangeServlet extends JAXMServlet implements ReqRespListener {

    public void init(ServletConfig servletConfig) throws ServletException {
        super.init(servletConfig);
    }    

    public SOAPMessage onMessage(SOAPMessage message) {
		SOAPMessage response = null;
		String c1 = null, c2 = null;
        System.out.println("Messaggio ricevuto");

        try {
            message.writeTo(System.out);
			
			SOAPPart 		sp  = message.getSOAPPart();
			SOAPEnvelope 	env = sp.getEnvelope();
			SOAPHeader 		hdr = env.getHeader();
			SOAPBody 		bdy = env.getBody();
			
			Iterator ii = bdy.getChildElements();
			while( ii.hasNext() ) {
				SOAPElement e = (SOAPElement)ii.next();
				
				Iterator kk = e.getChildElements();
				while( kk.hasNext() ) {
					SOAPElement ee = (SOAPElement)kk.next();
					String name = ee.getElementName().getLocalName();
					
					if( name.equals("country1") ) {
						c1 = ee.getValue();
					}
					if( name.equals("country2") ) {
						c2 = ee.getValue();
					}
				}
			}
			
			float f = getRate( c1, c2 );
			response = createResponse( f );
			
        } catch(Exception e) {
			e.printStackTrace();        	
        }
		return response;
    }
	
	protected float getRate( String c1, String c2 ) {
		return (float)10.55;
	}
	
	protected SOAPMessage createResponse( float f ) throws SOAPException {
		MessageFactory 	mf  = MessageFactory.newInstance();
		SOAPMessage 	msg = mf.createMessage();
		SOAPPart 		sp  = msg.getSOAPPart();
		SOAPEnvelope 	env = sp.getEnvelope();
		SOAPHeader 		hdr = env.getHeader();
		SOAPBody 		bdy = env.getBody();
		
		String xsi = "http://www.w3.org/2001/XMLSchema-instance";
		env.addNamespaceDeclaration("xsi", xsi); 
		env.addNamespaceDeclaration("xsd", "http://www.w3.org/2001/XMLSchema");
		env.addNamespaceDeclaration("soapenc", "http://schemas.xmlsoap.org/soap/encoding/");
		env.setEncodingStyle("http://schemas.xmlsoap.org/soap/encoding/");

		javax.xml.soap.Name xsiTypeString = env.createName("type", "xsi", xsi);
		
		SOAPBodyElement gltp
			= bdy.addBodyElement(env.createName("getRateResponse",
			"ns1",
			"urn:xmethods-CurrencyExchange"));

		SOAPElement e1 =
		gltp.addChildElement(env.createName("Result")).addTextNode(""+f);
		e1.addAttribute( xsiTypeString, "xsd:float" );
		
		return msg;
	}
}

